program Gmptest;

uses SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics,
     Controls, Forms, Dialogs, Menus, ExtCtrls, WinCrt,
  gmp in 'GMP.PAS',
  util in 'c:\ssh\util.pas';

var x, y, z, res: MP_INT;
    i: Integer;

function mp_alloc(size: Integer): PChar; export;
begin
  Result := StrAlloc(size);
end;

function mp_realloc(old: PChar; oldsize, newsize: Integer): PChar; export;
var newstring: PChar;
    minsize: Integer;
begin
  newstring := StrAlloc(newsize);
  minsize := oldsize;
  if newsize < minsize
    then minsize := newsize;
  Move(old^, newstring^, minsize);
  StrDispose(old);
  Result := newstring;
end;

procedure mp_free(old: PChar; size: Integer); export;
begin
  StrDispose(old);
end;

procedure log(s, context: PChar); export;
begin
  Writeln('log: ', StrPas(s));
end;

function mpstr(var mp: MP_INT): String;
var str: PChar;
begin
  str := mpz_get_str(nil, 10, mp);
  Result := StrPas(str);
  StrDispose(str);
end;

begin
  Writeln('Delphi');

  gmp_set_log(log, nil);

  Writeln('About to set memory functions');
  mp_set_memory_functions(mp_alloc, mp_realloc, mp_free);

  Writeln('Plain init of x.');
  mpz_init(x);

  Writeln('About to initialize variables');
  mpz_init_set_ui(x, 5);
  Writeln('Initialization of x done.');
  mpz_init_set_ui(y, 17);
  mpz_init_set_ui(z, 3);

  Writeln('About to print.');
  Writeln('x: ', mpstr(x));
  Writeln('y: ', mpstr(y));
  Writeln('z: ', mpstr(z));

  Writeln('About to multiply.');
  mpz_mul(z, x, y);
  Writeln('mul = ', mpstr(z));

  Writeln('About to divide.');
  mpz_div(z, y, x);
  Writeln('x/y = ', mpstr(z));

  mpz_init(res);
  mpz_set_ui(y, 1);
  for i := 1 to 10 do
    begin
      mpz_set_ui(x, 10000);
      mpz_mul(y, y, x);
      mpz_pow_ui(x, x, i);
      Writeln('size=', mpz_sizeinbase(x, 10));
      Writeln('x hex: ', StrPas(mpz_get_str(nil, 16, x)));
      Writeln('10^', i, ' = ', mpstr(x));
      Writeln('x.alloc=', x.alloc, ' x.size=', x.size);
      Writeln('y hex: ', StrPas(mpz_get_str(nil, 16, y)));
      Writeln('y: ', mpstr(y));
      Writeln('y.alloc=', y.alloc, ' y.size=', y.size);
{      mpz_set_ui(x, 10);
      mpz_pow_ui(y, x, i);
      mpz_set_ui(x, 3);
      mpz_set_ui(y, i);
      mpz_set_ui(z, 10);
      mpz_pow_ui(z, z, 20);
      mpz_powm(res, x, y, z);
      Writeln(mpstr(x), '^', mpstr(y), ' mod ', mpstr(z), ' = ', mpstr(res));
}      Application.ProcessMessages;
    end;

  mpz_clear(x);
  mpz_clear(y);
  mpz_clear(z);
  mpz_clear(res);

  ErrorDialog('At end.', 0);
end.

